<template>
  <modal
    id="login-popup"
    ref="modal"
    title="ورود به حساب کاربری"
    :icon="
      'ic-login-phone-' +
        (state === 'login' ? 'number' : 'password') +
        ' d-none d-sm-block'
    "
    color="primary"
    :show.sync="show"
    :simple="false"
    :loading="loading"
    @next="next"
  >
    <div class="transition-parent" :class="transitionDirection">
      <transition name="slide-x" mode="out-in">
        <form
          v-if="state === 'login'"
          key="login"
          class="text-center mt-4 mb-3"
          data-vv-scope="form-1"
          @submit.prevent="sendCode"
        >
          <div class="mx-auto form-inner">
            <div class="d-flex mb-3">
              <span class="d-none align-items-center pl-3 d-sm-flex">
                <i class="ic-tablet font-20 text-muted" />
              </span>
              <input
                v-model="username"
                v-number
                v-validate="'required|email-or-mobile'"
                v-focus
                type="text"
                name="phone"
                class="form-control form-control-lg dir-ltr-focus validate-bg"
                placeholder="شماره موبایل یا ایمیل"
                data-vv-as="موبایل یا ایمیل"
              />
            </div>
            <p class="text-muted mb-0">
              برای وارد شدن به حساب کاربری شماره موبایل یا ایمیل خود را وارد
              کنید
            </p>
          </div>
        </form>
        <form
          v-else
          key="verify"
          class="text-center mt-4 mb-3"
          data-vv-scope="form-2"
          @submit.prevent="verifyCode"
        >
          <div class="mx-auto form-inner">
            <p class="text-muted">
              <span>یک پیامک/ایمیل حاوی کد فعالسازی به</span>
              <span
                class="btn btn-outline-primary btn-sm"
                @click="state = 'login'"
              >
                {{ username }}
              </span>
              <span>ارسال شد،</span>
              <span>کد دریافت شده را در کادر زیر وارد کنید</span>
            </p>
            <div class="d-flex mb-3">
              <div class="d-flex align-items-center pl-3">
                <i class="ic-password font-20 text-muted" />
              </div>
              <input
                v-model="code"
                v-validate="'required|numeric|length:4'"
                v-number
                v-focus
                type="tel"
                name="code"
                class="form-control form-control-lg  validate-bg"
                placeholder="کد تایید"
                data-vv-as="کد تایید"
                maxlength="4"
                minlength="4"
              />
            </div>
            <p v-if="timer.text" class="text-muted mb-0">
              <span>ارسال مجدد بعد از</span>
              <span class="d-inline-block" style="width:30px">
                {{ timer.text }}
              </span>
            </p>
            <span
              v-else
              class="btn btn-outline-primary btn-sm"
              @click="sendCode"
            >
              {{ 'ارسال مجدد کد' }}
            </span>
          </div>
        </form>
      </transition>
    </div>
  </modal>
</template>

<script>
export default {
  name: 'LoginPopup',
  syncStore: ['show:showLogin', 'state:loginState'],
  data() {
    return {
      loading: false,
      username: '',
      code: '',
      transitionDirection: '',
      timer: {
        start: 0,
        text: '',
        timeout: null,
        allowed: 4 * 60
      }
    }
  },
  computed: {},
  watch: {
    state(after) {
      this.transitionDirection = after === 'verify' ? '' : 'direction-prev'
      if (after === 'verify') {
        this.timer.start = new Date().getTime()
        this.updateTimer()
      } else {
        this.stopTimer()
      }
    },
    code(after, before) {
      if (after && after.length === 4 && before && before.length === 3) {
        this.verifyCode()
      }
    }
  },
  methods: {
    next() {
      if (this.state === 'login') this.sendCode()
      else this.verifyCode()
    },
    sendCode() {
      if (this.loading) return
      this.$store
        .dispatch('user/signUp', {
          $vm: this,
          $scope: 'form-1',
          $data: {
            username: this.username
          }
        })
        .then(() => {
          if (window.innerWidth > 500)
            this.$message.success('کد تایید برای شما ارسال شد')
        })
    },
    verifyCode() {
      if (this.loading) return
      this.$store
        .dispatch('user/verifyCode', {
          $vm: this,
          $scope: 'form-2',
          $data: {
            username: this.username,
            code: this.code
          }
        })
        .then(() => {
          this.show = false
          this.$store.dispatch('loadBasicData')
          this.$message.success('با موفقیت وارد شدید!')
        })
    },
    updateTimer() {
      window.clearTimeout(this.timer.timeout)
      let elapsed =
        this.timer.allowed -
        Math.floor(new Date().getTime() - this.timer.start) / 1000

      if (elapsed <= 0) return this.stopTimer()

      this.timer.text =
        Math.floor(elapsed / 60) + ':' + Math.floor(elapsed % 60)
      this.timer.timeout = window.setTimeout(this.updateTimer, 1000)
    },
    stopTimer() {
      window.clearTimeout(this.timer.timeout)
      this.timer.text = ''
    }
  }
}
</script>

<style lang="scss">
#login-popup {
  .transition-parent {
    overflow-x: hidden;
    padding: 0 5px;
  }
  .form-inner {
    max-width: 350px;
    min-height: 150px;
  }
}
</style>
